// ************************************************************************************************************
// (c) copyright LazNet s.r.o.
// www.onlinetechnology.cz
//
// Tento software je chrnn autorskm prvem.
// Uivatel nen oprvnn odstranit ochrannou znmku autorskch prv (copyright).
// Uivatel nen oprvnn software koprovat, pronajmat, pjovat nebo jinm zpsobem umonit tetm osobm jeho vyuit.
// Uivatel nen oprvnn zdrojov kd nebo jeho sti koprovat i poskytnout tetm osobm.
// Uivatel je povinen uvat software v souladu s platnmi prvnmi pedpisy a licennmi podmnkami.
// ************************************************************************************************************
// 16.09.2014 - v.1.0.0 - 1.vydn
// 16.10.2014 - v.1.0.1 - pidna hystereze 0.5st

// sys140 obsahuje adresu pro zapis do DF
// sys141 obsahuje parametry 1
// sys142 obsahuje parametry 2
// ram[0-5] lcdtime a echotime pouziva
// ram[11-16] stav hystereze pro rele 1-6
// ram[100-149] -> nastaveni vystupu 1
// ram[100] -> automat
// ram[101] -> vypnuto
// ram[102] -> zapnuto
// ram[103,...] -> den
// ram[104,...] -> hod zap
// ram[105,...] -> min zap
// ram[106,...] -> hod vyp
// ram[107,...] -> min vyp
// ram[108,...] -> teplota
// ram[109,...] -> teplotni cidlo
// ram[150-199] -> nastaveni vystupu 2
// ram[150] -> automat
// ram[151] -> vypnuto
// ram[152] -> zapnuto
// ram[153,...] -> den
// ram[154,...] -> hod zap
// ram[155,...] -> min zap
// ram[156,...] -> hod vyp
// ram[157,...] -> min vyp
// ram[158,...] -> teplota
// ram[159,...] -> teplotni cidlo
// ram[200-249] -> nastaveni vystupu 3
// ram[200] -> automat
// ram[201] -> vypnuto
// ram[202] -> zapnuto
// ram[203,...] -> den
// ram[204,...] -> hod zap
// ram[205,...] -> min zap
// ram[206,...] -> hod vyp
// ram[207,...] -> min vyp
// ram[208,...] -> teplota
// ram[209,...] -> teplotni cidlo
// ram[250-299] -> nastaveni vystupu 4
// ram[250] -> automat
// ram[251] -> vypnuto
// ram[252] -> zapnuto
// ram[253,...] -> den
// ram[254,...] -> hod zap
// ram[255,...] -> min zap
// ram[256,...] -> hod vyp
// ram[257,...] -> min vyp
// ram[258,...] -> teplota
// ram[259,...] -> teplotni cidlo
// ram[300-349] -> nastaveni vystupu 5
// ram[300] -> automat
// ram[301] -> vypnuto
// ram[302] -> zapnuto
// ram[303,...] -> den
// ram[304,...] -> hod zap
// ram[305,...] -> min zap
// ram[306,...] -> hod vyp
// ram[307,...] -> min vyp
// ram[308,...] -> teplota
// ram[309,...] -> teplotni cidlo
// ram[350-399] -> nastaveni vystupu 6
// ram[350] -> automat
// ram[351] -> vypnuto
// ram[352] -> zapnuto
// ram[353,...] -> den
// ram[354,...] -> hod zap
// ram[355,...] -> min zap
// ram[356,...] -> hod vyp
// ram[357,...] -> min vyp
// ram[358,...] -> teplota
// ram[359,...] -> teplotni cidlo
// ram[500] -> pozadovany novy stav rele

//glob.promenne!!!
var _gram;
var _grele;

//promnn
var _pom;     //obecna pomocna
var _adr;     //0-7259 zapis pres sys[99] a write_dataflash(xxx);
var _ram;     //index ram pole 0-511
var _ram1;    //index ram pole 0-511
var _ram2;    //index ram pole 0-511
var _t1;      //teplota nebo cas
var _t2;      //teplota nebo cas
var _takt;    //akt.teplota
var _tr;      //rozdil teplot
var _ta;      //akt.cas
var _den;     //cislo dne
var _rele;    //rele

#define DF sys[99]
#define ADR sys[140]
#define PAR1 sys[141]
#define PAR2 sys[142]

// *******  globalni procedury  **********
lcdtime
{
 ram[0]=sys[8] / 10;
 ram[1]=sys[8] % 10;
 ram[2]=sys[9] / 10;
 ram[3]=sys[9] % 10;
 ram[4]=sys[10] / 10;
 ram[5]=sys[10] % 10;
 lcd_echo(1,4,1,ram[0],ram[1]':',ram[2],ram[3]':',ram[4], ram[5]);
}

echotime
{
 ram[0]=sys[8] / 10;
 ram[1]=sys[8] % 10;
 ram[2]=sys[9] / 10;
 ram[3]=sys[9] % 10;
 ram[4]=sys[10] / 10;
 ram[5]=sys[10] % 10;
 echo(ram[0],ram[1]':',ram[2],ram[3]':',ram[4], ram[5]);
}

savetodf
{
 if (ADR>0 && ADR<500 && PAR1>=1000000) {
  _adr=ADR;
  DF=PAR1/1000000;
  DF-=1000;
  ram[_adr]=DF;
  write_dataflash(_adr);
  echo(_adr,':',DF,',',ram[_adr]);
  _pom=PAR1 % 1000000;
  DF=_pom/1000;
  _adr++;
  ram[_adr]=DF;
  write_dataflash(_adr);
  echo(_adr,':',DF,',',ram[_adr]);
  DF=_pom % 1000;
  _adr++;
  ram[_adr]=DF;
  write_dataflash(_adr);
  echo(_adr,':',DF,',',ram[_adr]);
  if (PAR2>=1000000000) {
   DF=PAR2/10000000;
   DF-=100;
   _adr++;
   ram[_adr]=DF;
   write_dataflash(_adr);
   echo(_adr,':',DF,',',ram[_adr]);
   _pom=PAR2 % 10000000;
   DF=_pom/100000;
   _adr++;
   ram[_adr]=DF;
   write_dataflash(_adr);
   echo(_adr,':',DF,',',ram[_adr]);
   _pom=_pom % 100000;
   DF=_pom/100;
   _adr++;
   ram[_adr]=DF;
   write_dataflash(_adr);
   echo(_adr,':',DF,',',ram[_adr]);
   DF=_pom % 100;
   _adr++;
   ram[_adr]=DF;
   write_dataflash(_adr);
   echo(_adr,':',DF,',',ram[_adr]);
  }
  echo('Hodnota ', sys[141], ' a ', sys[142], ' ulozena do DF');
  sys[140]=0;
  sys[141]=0;
  sys[142]=0;
  wait(1000);
 }
}

df2ram
{
 _ram=100;
 label df2ram1:
  read_dataflash(_ram);
  ram[_ram]=DF;
  _ram++;
 if(_ram<400) goto df2ram1;
 echotime();
 echo('Parametry nacteny z DF do RAM');
 wait(1000);  //1s aby se neopakoval
}

autrele
{
 _den=((sys[4] / 86400) + 4) % 7;  //0=nedle, 1=pondl, ...
 if(_den==0){
  _den=7;  //nedele=7
 }  
 //akt.cas
 _ta=sys[8]*100;
 _ta+=sys[9];

 //vynulovat pozadovany stav rele 
 ram[500]=0;
 //vsechny programy
 _ram=_gram;
 label rele1:
  if(ram[_ram]>0){
   if( (_den==1 && (ram[_ram]==1 || ram[_ram]==8 || ram[_ram]==9)) || (_den==2 && (ram[_ram]==2 || ram[_ram]==8 || ram[_ram]==9)) || (_den==3 && (ram[_ram]==3 || ram[_ram]==8 || ram[_ram]==9)) || (_den==4 && (ram[_ram]==4 || ram[_ram]==8 || ram[_ram]==9)) || (_den==5 && (ram[_ram]==5 || ram[_ram]==8 || ram[_ram]==9)) || (_den==6 && (ram[_ram]==6 || ram[_ram]==8 || ram[_ram]==10)) || (_den==7 && (ram[_ram]==7 || ram[_ram]==8 || ram[_ram]==10)) ){
    //cas v intervalu
    _pom=_ram+1;
    _t1=ram[_pom]*100;
    _pom=_ram+2;
    _t1+=ram[_pom];
    _pom=_ram+3;
    _t2=ram[_pom]*100;
    _pom=_ram+4;
    _t2+=ram[_pom];
    if (_ta>=_t1 && _ta<=_t2){
     ram[500]=1;
    }
    //vypinaci teplota
    _pom=_ram+5;
    _t1=ram[_pom]*10;
    _pom=_ram+6;
    if(ram[_pom]>0){
     _pom=ram[_pom]+309;
     _takt=sys[_pom];
     if (_takt>=_t1 && _takt<20000 && _takt!=850) {
      ram[500]=0;
      _pom=_grele-220;  //231-220=11 -> ram[11-16] stav hyst
      ram[_pom]=1;  //nastav hyst
     } else {
      //hystereze 0.5st
      _t1=_t1-50;
      if (_takt>=_t1 && _takt<20000 && _takt!=850) {
       _pom=_grele-220;  //231-220=11 -> ram[11-16] stav hyst
       if (ram[_pom]==1){
        ram[500]=0;
       }
      }
     }
    }
   }
  }
  _ram+=7;
 if(_ram<=_gram+42) goto rele1;
 //nastavit rele on/off dle ram[500]
 if (ram[500]==0 && sys[_grele]!=0){
  echotime();
  _pom=_grele-230;
  echo('Vystup ', _pom, ' vypnut');
  sys[_grele]=0;    //vyp
 }
 if (ram[500]==1 && sys[_grele]==0){
  echotime();
  _pom=_grele-230;
  echo('Vystup ', _pom, ' zapnut');
  _pom+=10;
  ram[_pom]=0;  //vynuluj hyst
  sys[_grele]=255;  //zap
 }
}

rele
{
 //rucni/aut nastaveni
 if (ram[100]==1){
  _gram=103;
  _grele=231;
  autrele();
 }
 if (ram[101]==1 && sys[231]!=0){
  echotime();
  echo('Vystup 1 rucne vypnut');
  sys[231]=0;
 }
 if (ram[102]==1 && sys[231]==0){
  echotime();
  echo('Vystup 1 rucne zapnut');
  sys[231]=255;
 }
 if (ram[150]==1){
  _gram=153;
  _grele=232;
  autrele();
 }
 if (ram[151]==1 && sys[232]!=0){
  echotime();
  echo('Vystup 2 rucne vypnut');
  sys[232]=0;
 }
 if (ram[152]==1 && sys[232]==0){
  echotime();
  echo('Vystup 2 rucne zapnut');
  sys[232]=255;
 }
 if (ram[200]==1){
  _gram=203;
  _grele=233;
  autrele();
 }
 if (ram[201]==1 && sys[233]!=0){
  echotime();
  echo('Vystup 3 rucne vypnut');
  sys[233]=0;
 }
 if (ram[202]==1 && sys[233]==0){
  echotime();
  echo('Vystup 3 rucne zapnut');
  sys[233]=255;
 }
 if (ram[250]==1){
  _gram=253;
  _grele=234;
  autrele();
 }
 if (ram[251]==1 && sys[234]!=0){
  echotime();
  echo('Vystup 4 rucne vypnut');
  sys[234]=0;
 }
 if (ram[252]==1 && sys[234]==0){
  echotime();
  echo('Vystup 4 rucne zapnut');
  sys[234]=255;
 }
 if (ram[300]==1){
  _gram=303;
  _grele=235;
  autrele();
 }
 if (ram[301]==1 && sys[235]!=0){
  echotime();
  echo('Vystup 5 rucne vypnut');
  sys[236]=0;
 }
 if (ram[302]==1 && sys[235]==0){
  echotime();
  echo('Vystup 5 rucne zapnut');
  sys[235]=255;
 }
 if (ram[350]==1){
  _gram=353;
  _grele=236;
  autrele();
 }
 if (ram[351]==1 && sys[236]!=0){
  echotime();
  echo('Vystup 6 rucne vypnut');
  sys[237]=0;
 }
 if (ram[352]==1 && sys[236]==0){
  echotime();
  echo('Vystup 6 rucne zapnut');
  sys[237]=255;
 }
}

init
{
 sys[140]=0;
 sys[141]=0;
 sys[142]=0;
 sys[143]=0;
 sys[144]=0;
 sys[145]=0;
 sys[146]=0;
 sys[147]=0;
 ram[11]=0;
 ram[12]=0;
 ram[13]=0;
 ram[14]=0;
 ram[15]=0;
 ram[16]=0;

 //prvotni nacteni hodnot z DF do RAM
 df2ram();
 echo('Start programu - termostat micro IO6 v.1.0.1');
}

main
{
 //ulozeni parametru z web promennych do dataflash
 savetodf();

 //nacteni parametru z DF do ram
 _pom=sys[4] % 86400;  //unixtime - jen 1x za 24hod
 if(_pom==60){ df2ram(); }  //1hod 1min 1sek (predpokladam velky frkot v celou - proto az v celou+1min)

 //ovladani rele
 rele();
}